/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.listener;

import de.steamwar.fightsystem.Config;
import de.steamwar.fightsystem.states.FightState;
import de.steamwar.fightsystem.states.StateDependentTask;
import de.steamwar.linkage.Linked;
import org.bukkit.Location;
import org.bukkit.entity.WindCharge;

@Linked
public class WindchargeStopper {

    public WindchargeStopper() {
        new StateDependentTask(true, FightState.Running, this::run, 1, 1);
    }

    private static final int middleLine = Config.SpecSpawn.getBlockZ();

    private static final Class<?> windChargeClass = WindCharge.class;

    private void run() {
        Recording.iterateOverEntities(windChargeClass::isInstance, entity -> {
            Location location = entity.getLocation();
            Location prevLocation = location.clone().subtract(entity.getVelocity());

            boolean passedMiddle = location.getBlockZ() > middleLine && prevLocation.getBlockZ() > middleLine ||
                    location.getBlockZ() < middleLine && prevLocation.getBlockZ() < middleLine;

            if (!passedMiddle) {
                entity.remove();
            }
        });
    }
}
